#include "../main/bootpack.h"
#include <string.h>
#include "hankaku.h"
#include "clcfont.h"
#include "mgxfont.h"

int *tmp;
extern char cpath[256], epath[1024];
#define KEYCMD_LED		0xed

char *_hankaku;
char *_clcfont;
char *_mgxfont;

int *init_fat(char *currentpath)
{
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;

	/* PATH̏ */
	strcpy(cpath, currentpath);
	strcpy(epath, currentpath);
	/* FAT̓WJAe[u */
	tmp = (int *) memman_alloc_4k(memman, 4 * 2880);
	file_readfat(tmp, (unsigned char *) (ADR_DISKIMG + 0x000200));
	file_inittbl();

	/* t@Cꗗpt@Cifile.txtj쐬 */
	file_list(tmp);

	return tmp;
}

void init_allowMouseKeyB()
{
	io_out8(PIC0_IMR, 0xf8); /* PITPIC1ƃL[{[h(11111000) */
	io_out8(PIC1_IMR, 0xef); /* }EX(11101111) */
	return;
}

void init_font(void)
{
	extern char hankaku[4096];
	extern char clcfont[4096];
	extern char mgxfont[4096];

	int size, size2;
	struct MEMMAN *memman = (struct MEMMAN *) MEMMAN_ADDR;
	char *buf;

	_hankaku = (char *) memman_alloc_4k(memman, 4096);
	memcpy(_hankaku, hankaku, 4096);

	if (size >= 17) {
		size2 = tek_getsize(_hankaku);
		if (size2 > 0) {	/* tekkĂ */
			buf = (char *) memman_alloc_4k(memman, size2);
			tek_decomp(_hankaku, buf, size2);
			memman_free_4k(memman, (int) _hankaku, 4096);
			_hankaku = buf;
		}
	}

	_clcfont = (char *) memman_alloc_4k(memman, 4096);
	memcpy(_clcfont, clcfont, 4096);

	if (size >= 17) {
		size2 = tek_getsize(_clcfont);
		if (size2 > 0) {	/* tekkĂ */
			buf = (char *) memman_alloc_4k(memman, size2);
			tek_decomp(_clcfont, buf, size2);
			memman_free_4k(memman, (int) _clcfont, 4096);
			_clcfont = buf;
		}
	}

	_mgxfont = (char *) memman_alloc_4k(memman, 4096);
	memcpy(_mgxfont, mgxfont, 4096);

	if (size >= 17) {
		size2 = tek_getsize(_mgxfont);
		if (size2 > 0) {	/* tekkĂ */
			buf = (char *) memman_alloc_4k(memman, size2);
			tek_decomp(_mgxfont, buf, size2);
			memman_free_4k(memman, (int) _mgxfont, 4096);
			_mgxfont = buf;
		}
	}
	
}

//unsigned long chipset_read()
//{
//	io_out32(0x0CF8, 0x80000000);
//	return io_in32(0x0CFC);
//}
//
//void chipset()
//{
//	unsigned long c = chipset_read();
//	char *ch;
//
//	sprintf(ch, "0x%X", c);
//	msgbox(ch);
//	return;
//}
